
function FlightTime_OnLoad() 
	this:RegisterEvent("PLAYER_CONTROL_LOST");
	this:RegisterEvent("PLAYER_CONTROL_GAINED");
	this:RegisterEvent("VARIABLES_LOADED");
	this:RegisterEvent("TAXIMAP_OPENED");
	this:RegisterEvent("TAXIMAP_CLOSED");
	
	SlashCmdList["FLIGHTTIME"] = FlightTime_Slash_Handler
	SLASH_FLIGHTTIME1 = "/ft"
	SLASH_FLIGHTTIMEE2 = "/flighttime"
	
	Saved_GameTooltipOnShowFunction = GameTooltip:GetScript("OnShow")
	GameTooltip:SetScript("OnShow",FT_ShowTooltip)

	taxiMapIsOpen = 0
end

function FlightTime_OnEvent(event)
	if (event == "VARIABLES_LOADED") then
		FT_LoadVars()
		FT_ChatMsg("FlightTime Loaded! Type /ft or /flighttime for more info")
	elseif (event == "PLAYER_CONTROL_LOST") then
		FT_Player_Control_Lost()
		-- check to see if they are on a griffon
	elseif (event == "PLAYER_CONTROL_GAINED") then
		FT_Player_Control_Gained()
		-- check to see if they were just on a griffon
	elseif (event == "TAXIMAP_OPENED") then
		taxiMapIsOpen = 1
		FT_LoadTaxiFunctions()
	elseif (event == "TAXIMAP_CLOSED") then
		taxiMapIsOpen = 0
		FT_CheckCloseTime = GetTime()
		FT_RestoreTaxiFunctions()
	end
end

function FlightTime_Slash_Handler(msg)
	argv = {};
	for arg in string.gmatch(string.lower(msg), '[%a%d%-%.]+') do
		table.insert(argv, arg);
	end
	
	if (argv[1] == "forcehide") then
		if (FTDB["forcehide"] == 0) then 
			FTDB["forcehide"] = 1
			FT_ChatMsg("FlightTime display de-activated, data to new Flight Path's will still be recorded")
		else
			if (UnitOnTaxi("player")) then FlightTime:Show() end
			FTDB["forcehide"] = 0
			FT_ChatMsg("Flight display activated")
		end
	elseif (argv[1] == "color") then
		if (argv[2]) then
			if (argv[2] == "blue") then
				FTDB["color"] = argv[2]
				FT_ChatMsg("FlightTime background color set to " .. FTDB["color"])
			elseif (argv[2] == "green") then
				FTDB["color"] = argv[2]
				FT_ChatMsg("FlightTime background color set to " .. FTDB["color"])
			elseif (argv[2] == "yellow") then
				FTDB["color"] = argv[2]
				FT_ChatMsg("FlightTime background color set to " .. FTDB["color"])
			elseif (argv[2] == "red") then
				FTDB["color"] = argv[2]
				FT_ChatMsg("FlightTime background color set to " .. FTDB["color"])
			else
				FT_ChatMsg("Invalid color: " .. argv[2] .. ". Example: '/ft color blue'")
			end
		else
			FT_ChatMsg("You must specify a color! Example: '/ft color blue'")
		end
	elseif (argv[1] == "bgtoggle") then
		if (FTDB["bgtoggle"] == 0) then 
			FTDB["bgtoggle"] = .5
			FT_ChatMsg("FlightTime background enabled")
		else
			FTDB["bgtoggle"] = 0
			FT_ChatMsg("FlightTime background disabled")
		end
	elseif (argv[1] == "display") then
		if (FTDB["display"] == 0) then 
			FTDB["display"] = 1
			FT_ChatMsg("FlightTime now displaying Destination and time remaining")
		else
			FTDB["display"] = 0
			FT_ChatMsg("FlightTime only showing time remaining")
		end
	elseif (argv[1] == "record") then
		if (FTDB["notify"] == 0) then 
			FTDB["notify"] = 1
			FT_ChatMsg("FlightTime will no longer display when recording data")
		else
			FTDB["notify"] = 0
			if (UnitOnTaxi("player")) then FlightTime:Show() end
			FT_ChatMsg("FlightTime will now display when recording data")
		end
	elseif (argv[1] == "move") then
		if (FT_Mover:IsShown()) then
			FT_Mover:Hide()
		else
			FTDB["forcehide"] = 0
			FT_Mover:Show()
		end
	else
		if (argv[1] == nil) then
			FlightTime_Help()
		else
			FT_ChatMsg("Invalid command: " .. argv[1] .. ". Type /ft for more info")
		end
	end
end

function FlightTime_Help()
	FT_ChatMsg("FlightTime Commands");
	FT_ChatMsg("----------------------------------");
	FT_ChatMsg("/ft forcehide - toggles display during flight (times are still recorded)");
	FT_ChatMsg("/ft color green/yellow/blue/red - sets background color");
	FT_ChatMsg("/ft bgtoggle - toggles display of background");
	FT_ChatMsg("/ft record - toggles display when data is being recorded for the first time");
	FT_ChatMsg("/ft display - toggles short or long display of time left");
	FT_ChatMsg("/ft move - toggles move window");
end

function FT_Round(num, vdp)
	local vdp = vdp or 2
	return tonumber( string.format("%."..vdp.."f", num ) )
end

function FT_FormatDisplay(recording)
	if (FTDB["forcehide"] == 1) then FlightTime:Hide() end
	if (recording == 1) then
		if (FTDB["notify"] == 1) then FlightTime:Hide() end
	end
	if (FTDB["color"] == "blue") then
		FlightTime:SetBackdropColor(0,0,1,FTDB["bgtoggle"])
	elseif (FTDB["color"] == "green") then
		FlightTime:SetBackdropColor(0,1,0,FTDB["bgtoggle"])
	elseif (FTDB["color"] == "red") then
		FlightTime:SetBackdropColor(1,0,0,FTDB["bgtoggle"])
	else --yellow
		FlightTime:SetBackdropColor(1,1,0,FTDB["bgtoggle"])
	end
end

function FT_LoadVars()
	if (FTDB == nil) then
		FTDB = {}
	end

	if (FTDB["forcehide"] == nil) then
		FTDB["forcehide"] = 0
	end
	if (FTDB["color"] == nil) then
		FTDB["color"] = "blue"
	end
	if (FTDB["bgtoggle"] == nil) then
		FTDB["bgtoggle"] = .5
	end
	if (FTDB["display"] == nil) then
		FTDB["display"] = 1
	end
	if (FTDB["notify"] == nil) then
		FTDB["notify"] = 0
	end
	if (FTDB["xoff"] == nil) then
		FTDB["xoff"] = 0
	end
	if (FTDB["yoff"] == nil) then
		FTDB["yoff"] = -150
	end
	
	
	pointsArray = nil
	pointsArray = {}
	FT_GoodToGo = 0
	FT_FormatDisplay(1)
	FT_Mover_Is_Shown = 0
end

function FT_ChatMsg(msg)
	if(DEFAULT_CHAT_FRAME) then
		DEFAULT_CHAT_FRAME:AddMessage("|cffffffff" .. msg);
	end
end
