function FT_Player_Control_Lost()
	if (GetTime() - FT_GoodToGo < 1) then
		FT_StartTime = GetTime() 
		FlightTime:Show()
	end
end

function FT_Player_Control_Gained()
	if (FlightTime:IsShown()) then
		FT_EndTime = GetTime()
		flight_time = FT_Round(FT_EndTime - FT_StartTime,0)
		
		if (FTDB[FT_StartPoint] == nil) then
			FTDB[FT_StartPoint] = {}
		end
		if (FTDB[FT_StartPoint][FT_EndPoint] == nil) then
			FT_ChatMsg("FlightTime: Saved data going from " .. FT_StartPoint .. " to " .. FT_EndPoint .. " (" .. FT_ConvertTime(flight_time) .. ")")
		end
		
		FTDB[FT_StartPoint][FT_EndPoint] = flight_time
		FlightTime:Hide()
	end
end

function FT_LoadTaxiFunctions()
	for i=1,NumTaxiNodes() do 
		button = getglobal("TaxiButton" .. i) 
		button.oldOnClick = button:GetScript("OnClick") 
		button.oldOnEnter = button:GetScript("OnEnter")
		button:SetScript("OnEnter",FT_EnterTaxiButton)
		button:SetScript("OnClick",FT_ClickTaxiButton)
		
		if (TaxiNodeGetType(i) == "CURRENT") then
			FT_StartPoint = string.gsub(TaxiNodeName(i), "(%,.*)", "")
		end
	end
	
	FT_NumToRestore = NumTaxiNodes()
end

function FT_RestoreTaxiFunctions()
	FT_GoodToGo = GetTime()
	if (FT_NumToRestore) then
		for i=1,FT_NumToRestore do
			button = getglobal("TaxiButton" .. i) 
			button:SetScript("OnClick",button.oldOnClick) 
			button:SetScript("OnEnter",button.oldOnEnter)
		end
	end
end

function FT_EnterTaxiButton()
	if (this) then
		FT_CurrentNode = string.gsub(this:GetName(),"TaxiButton","")
		FT_CurrentNode = tonumber(FT_CurrentNode)
		this.oldOnEnter()
	end
end

function FT_ClickTaxiButton()
	if (this) then
		num = string.gsub(this:GetName(),"TaxiButton","")
		num = tonumber(num)
		name = TaxiNodeName(num)
		
		FT_EndPoint = string.gsub(name, "(%,.*)", "")
		this.oldOnClick()
	end
end

function FlightTime_UpdateTime()
	xoff, yoff = FT_Get_Offsets(FlightTime, UIParent, 'CENTER', 'CENTER')
	if ((xoff ~= FTDB['xoff']) or (yoff ~= FTDB['yoff'])) then
		FlightTime:ClearAllPoints()
		FlightTime:SetPoint("CENTER","UIParent","CENTER", FTDB['xoff'], FTDB['yoff']) 
	end

	if (UnitOnTaxi("player")) then
		if ( ((FTDB[FT_StartPoint]) and (FTDB[FT_StartPoint][FT_EndPoint])) or ((FTDB_Local[FT_StartPoint]) and (FTDB_Local[FT_StartPoint][FT_EndPoint])) ) then
			if ((FTDB[FT_StartPoint]) and (FTDB[FT_StartPoint][FT_EndPoint])) then
				ft_timetouse = FTDB[FT_StartPoint][FT_EndPoint]
			else
				ft_timetouse = FTDB_Local[FT_StartPoint][FT_EndPoint]
			end
			
			FT_FormatDisplay(0)
			
			if (FTDB["display"] == 1) then
				dispString = FT_EndPoint .. ' - '
			else
				dispString = ''
			end
			
			timeRemaining = FT_Round(ft_timetouse - (GetTime() - FT_StartTime),0)
			FlightTime_Text:SetText(dispString .. FT_ConvertTime(timeRemaining))
		else
			FT_FormatDisplay(1)
			timeonflight = GetTime() - FT_StartTime
			FlightTime_Text:SetText("Recording - " .. FT_StartPoint .. " to " .. FT_EndPoint .. " - " .. FT_ConvertTime(timeonflight))
		end
	elseif (FT_Mover_Is_Shown == 1) then
		FT_FormatDisplay(0)
		FlightTime_Text:SetText("Move Me!")
	end
end

function FT_ConvertTime(totalSeconds)
	totalSeconds = FT_Round(totalSeconds,0)
	if (totalSeconds < 0) then totalSeconds = 0 end -- don't display negative seconds
	minutes = math.floor(totalSeconds/60)
	seconds = totalSeconds - (minutes*60)
	seconds = tostring(seconds)
	if (string.len(seconds) == 1) then
		seconds = "0" .. seconds
	end
		dispString = minutes .. ":" .. seconds
	return dispString
end

function FT_ShowTooltip()
	if (taxiMapIsOpen == 1) then   
		TtText = GameTooltipTextLeft1:GetText()
		
		if (FT_CurrentNode) then
			for taxiNode=1,NumTaxiNodes() do
				if (TaxiNodeGetType(taxiNode) == "CURRENT") then
					FT_DeparturePoint = string.gsub(TaxiNodeName(taxiNode), "(%,.*)", "")
				end
			end
			
			FT_PotentialDestination = string.gsub(TaxiNodeName(FT_CurrentNode), "(%,.*)", "")
			
			if ((FTDB[FT_DeparturePoint]) and (FTDB[FT_DeparturePoint][FT_PotentialDestination])) then
				Flight_Time = FT_ConvertTime(FTDB[FT_DeparturePoint][FT_PotentialDestination])
			elseif ((FTDB_Local[FT_DeparturePoint]) and (FTDB_Local[FT_DeparturePoint][FT_PotentialDestination])) then
				Flight_Time = FT_ConvertTime(FTDB_Local[FT_DeparturePoint][FT_PotentialDestination])
			else
				Flight_Time = "Unknown"
			end
			if (FT_DeparturePoint ~= FT_PotentialDestination) then
				GameTooltip:AddLine("ETA: " .. Flight_Time, 1, 1, 1)
				GameTooltip:SetHeight(GameTooltip:GetHeight() + 15)
			end
		end
	end
	
	if (Saved_GameTooltipOnShowFunction) then
		Saved_GameTooltipOnShowFunction()
	end
end

function FT_Mover_Show()
	FT_ChatMsg("Left click a +/- button to move by 1, Right click a +/- button to move by 10")
	FT_Mover_Is_Shown = 1
	FlightTime:Show()
end

function FT_Mover_Hide()
	FT_Mover_Is_Shown = 0
	if (UnitOnTaxi("player") == false) then
		FlightTime:Hide()
	end
end

function FT_Mover_Handler(button)
	xoff, yoff = FT_Get_Offsets(FlightTime, UIParent, 'CENTER', 'CENTER')
	
	if (button == "LeftButton") then
		move = 1
	elseif (button == "RightButton") then
		move = 10;
	else
		move = 1;
	end
	
	if (this:GetID() == 1) then
		newx = xoff + move
		newy = yoff
	elseif (this:GetID() == 2) then
		newx = xoff - move
		newy = yoff
	elseif (this:GetID() == 3) then
		newx = xoff
		newy = yoff + move
	elseif (this:GetID() == 4) then
		newx = xoff
		newy = yoff - move
	elseif (this:GetID() == 5) then
		newx = 0
		newy = -150
	end
	
	FTDB["xoff"] = newx
	FTDB["yoff"] = newy
end

function FT_Get_Offsets(frame, baseframe, attachpoint, attachto)
	local x1, y1 = FT_Get_Position(frame, attachpoint);
	local x2, y2 = FT_Get_Position(baseframe, attachto);
	local xoffset, yoffset;
	if (x1 and x2 and y1 and y2) then
		local es1, es2 = 1, 1;
		if (baseframe.GetEffectiveScale) then
			es1 = baseframe:GetEffectiveScale();
		end
		if (frame.GetEffectiveScale) then
			es2 = frame:GetEffectiveScale();
		end
		xoffset = FT_Round(x1 - x2 * es1 / es2, 2);
		yoffset = FT_Round(y1 - y2 * es1 / es2, 2);
	end
	return xoffset, yoffset;
end

function FT_Get_Position(frame, attach)
	if (frame.GetCenter and (not frame:GetCenter())) then
		return;
	end
	local x, y;
	if (attach == "TOPLEFT") then
		x = frame:GetLeft();
		y = frame:GetTop();
	elseif (attach == "TOP") then
		x = frame:GetCenter();
		y = frame:GetTop();
	elseif (attach == "TOPRIGHT") then
		x = frame:GetRight();
		y = frame:GetTop();
	elseif (attach == "LEFT") then
		x = frame:GetLeft();
		_, y = frame:GetCenter();
	elseif (attach == "CENTER") then
		x, y = frame:GetCenter();
	elseif (attach == "RIGHT") then
		x = frame:GetRight();
		_, y = frame:GetCenter();
	elseif (attach == "BOTTOMLEFT") then
		x = frame:GetLeft();
		y = frame:GetBottom();
	elseif (attach == "BOTTOM") then
		x = frame:GetCenter();
		y = frame:GetBottom();
	elseif (attach == "BOTTOMRIGHT") then
		x = frame:GetRight();
		y = frame:GetBottom();
	end
	x = FT_Mround(x, 2);
	y = FT_Mround(y, 2);
	return x, y;
end

function FT_Mround(number, precision)
	if (precision > 0) then
		number = number * 10 ^ precision;
	end
	local remainder = number  - math.floor(number);
	if (remainder >= .5) then
		number = math.floor(number) + 1;
	else
		number = math.floor(number);
	end
	if (precision > 0) then
		number = number / 10 ^ precision;
	end
	return number;
end
